#!/usr/bin/env node
"use strict";var e,t=require("fs"),n=require("path"),o=require("os"),r=require("crypto"),s={exports:{}},a={name:"dotenv",version:"16.4.6",description:"Loads environment variables from .env file",main:"lib/main.js",types:"lib/main.d.ts",exports:{".":{types:"./lib/main.d.ts",require:"./lib/main.js",default:"./lib/main.js"},"./config":"./config.js","./config.js":"./config.js","./lib/env-options":"./lib/env-options.js","./lib/env-options.js":"./lib/env-options.js","./lib/cli-options":"./lib/cli-options.js","./lib/cli-options.js":"./lib/cli-options.js","./package.json":"./package.json"},scripts:{"dts-check":"tsc --project tests/types/tsconfig.json",lint:"standard",pretest:"npm run lint && npm run dts-check",test:"tap run --allow-empty-coverage --disable-coverage --timeout=60000","test:coverage":"tap run --show-full-coverage --timeout=60000 --coverage-report=lcov",prerelease:"npm test",release:"standard-version"},repository:{type:"git",url:"git://github.com/motdotla/dotenv.git"},funding:"https://dotenvx.com",keywords:["dotenv","env",".env","environment","variables","config","settings"],readmeFilename:"README.md",license:"BSD-2-Clause",devDependencies:{"@types/node":"^18.11.3",decache:"^4.6.2",sinon:"^14.0.1",standard:"^17.0.0","standard-version":"^9.5.0",tap:"^19.2.0",typescript:"^4.8.4"},engines:{node:">=12"},browser:{fs:!1}};var i=function(){if(e)return s.exports;e=1;const i=t,c=n,l=o,p=r,d=a.version,u=/(?:^|^)\s*(?:export\s+)?([\w.-]+)(?:\s*=\s*?|:\s+?)(\s*'(?:\\'|[^'])*'|\s*"(?:\\"|[^"])*"|\s*`(?:\\`|[^`])*`|[^#\r\n]+)?\s*(?:#.*)?(?:$|$)/gm;function f(e){console.log(`[dotenv@${d}][DEBUG] ${e}`)}function v(e){return e&&e.DOTENV_KEY&&e.DOTENV_KEY.length>0?e.DOTENV_KEY:process.env.DOTENV_KEY&&process.env.DOTENV_KEY.length>0?process.env.DOTENV_KEY:""}function g(e,t){let n;try{n=new URL(t)}catch(e){if("ERR_INVALID_URL"===e.code){const e=new Error("INVALID_DOTENV_KEY: Wrong format. Must be in valid uri format like dotenv://:key_1234@dotenvx.com/vault/.env.vault?environment=development");throw e.code="INVALID_DOTENV_KEY",e}throw e}const o=n.password;if(!o){const e=new Error("INVALID_DOTENV_KEY: Missing key part");throw e.code="INVALID_DOTENV_KEY",e}const r=n.searchParams.get("environment");if(!r){const e=new Error("INVALID_DOTENV_KEY: Missing environment part");throw e.code="INVALID_DOTENV_KEY",e}const s=`DOTENV_VAULT_${r.toUpperCase()}`,a=e.parsed[s];if(!a){const e=new Error(`NOT_FOUND_DOTENV_ENVIRONMENT: Cannot locate environment ${s} in your .env.vault file.`);throw e.code="NOT_FOUND_DOTENV_ENVIRONMENT",e}return{ciphertext:a,key:o}}function E(e){let t=null;if(e&&e.path&&e.path.length>0)if(Array.isArray(e.path))for(const n of e.path)i.existsSync(n)&&(t=n.endsWith(".vault")?n:`${n}.vault`);else t=e.path.endsWith(".vault")?e.path:`${e.path}.vault`;else t=c.resolve(process.cwd(),".env.vault");return i.existsSync(t)?t:null}function h(e){return"~"===e[0]?c.join(l.homedir(),e.slice(1)):e}const y={configDotenv:function(e){const t=c.resolve(process.cwd(),".env");let n="utf8";const o=Boolean(e&&e.debug);e&&e.encoding?n=e.encoding:o&&f("No encoding is specified. UTF-8 is used by default");let r,s=[t];if(e&&e.path)if(Array.isArray(e.path)){s=[];for(const t of e.path)s.push(h(t))}else s=[h(e.path)];const a={};for(const t of s)try{const o=y.parse(i.readFileSync(t,{encoding:n}));y.populate(a,o,e)}catch(e){o&&f(`Failed to load ${t} ${e.message}`),r=e}let l=process.env;return e&&null!=e.processEnv&&(l=e.processEnv),y.populate(l,a,e),r?{parsed:a,error:r}:{parsed:a}},_configVault:function(e){var t;t="Loading env from encrypted .env.vault",console.log(`[dotenv@${d}][INFO] ${t}`);const n=y._parseVault(e);let o=process.env;return e&&null!=e.processEnv&&(o=e.processEnv),y.populate(o,n,e),{parsed:n}},_parseVault:function(e){const t=E(e),n=y.configDotenv({path:t});if(!n.parsed){const e=new Error(`MISSING_DATA: Cannot parse ${t} for an unknown reason`);throw e.code="MISSING_DATA",e}const o=v(e).split(","),r=o.length;let s;for(let e=0;e<r;e++)try{const t=g(n,o[e].trim());s=y.decrypt(t.ciphertext,t.key);break}catch(t){if(e+1>=r)throw t}return y.parse(s)},config:function(e){if(0===v(e).length)return y.configDotenv(e);const t=E(e);return t?y._configVault(e):(n=`You set DOTENV_KEY but you are missing a .env.vault file at ${t}. Did you forget to build it?`,console.log(`[dotenv@${d}][WARN] ${n}`),y.configDotenv(e));var n},decrypt:function(e,t){const n=Buffer.from(t.slice(-64),"hex");let o=Buffer.from(e,"base64");const r=o.subarray(0,12),s=o.subarray(-16);o=o.subarray(12,-16);try{const e=p.createDecipheriv("aes-256-gcm",n,r);return e.setAuthTag(s),`${e.update(o)}${e.final()}`}catch(e){const t=e instanceof RangeError,n="Invalid key length"===e.message,o="Unsupported state or unable to authenticate data"===e.message;if(t||n){const e=new Error("INVALID_DOTENV_KEY: It must be 64 characters long (or more)");throw e.code="INVALID_DOTENV_KEY",e}if(o){const e=new Error("DECRYPTION_FAILED: Please check your DOTENV_KEY");throw e.code="DECRYPTION_FAILED",e}throw e}},parse:function(e){const t={};let n,o=e.toString();for(o=o.replace(/\r\n?/gm,"\n");null!=(n=u.exec(o));){const e=n[1];let o=n[2]||"";o=o.trim();const r=o[0];o=o.replace(/^(['"`])([\s\S]*)\1$/gm,"$2"),'"'===r&&(o=o.replace(/\\n/g,"\n"),o=o.replace(/\\r/g,"\r")),t[e]=o}return t},populate:function(e,t,n={}){const o=Boolean(n&&n.debug),r=Boolean(n&&n.override);if("object"!=typeof t){const e=new Error("OBJECT_REQUIRED: Please check the processEnv argument being passed to populate");throw e.code="OBJECT_REQUIRED",e}for(const n of Object.keys(t))Object.prototype.hasOwnProperty.call(e,n)?(!0===r&&(e[n]=t[n]),o&&f(!0===r?`"${n}" is already defined and WAS overwritten`:`"${n}" is already defined and was NOT overwritten`)):e[n]=t[n]}};return s.exports.configDotenv=y.configDotenv,s.exports._configVault=y._configVault,s.exports._parseVault=y._parseVault,s.exports.config=y.config,s.exports.decrypt=y.decrypt,s.exports.parse=y.parse,s.exports.populate=y.populate,s.exports=y,s.exports}();i.config();(async()=>{try{const e=process.env.VALIDATED_TRANSLATIONS_PATH||n.join(process.cwd(),"src","translations"),o=t.existsSync(n.join(e,"validatedTranslations.js"))?n.join(e,"validatedTranslations.js"):n.join(e,"validatedTranslations.ts");if(!t.existsSync(o))throw new Error(`Translations file not found. Expected "validatedTranslations.js" or "validatedTranslations.ts" in ${e}.`);console.log(`Using translations from: ${o}`);const{validatedTranslations:r}=await import(o),s=Object.keys(r[0]).filter((e=>"key"!==e));for(const e of s){const o=r.reduce(((t,n)=>{if(!n[e])throw new Error(`Missing translation for key '${n.key}' in locale '${e}'`);return t[n.key]=n[e],t}),{}),s=n.join(process.cwd(),"public","translations",`${e}.json`);t.writeFileSync(s,JSON.stringify(o,null,2),"utf-8"),console.log(`Generated ${s}`)}}catch(e){e instanceof Error?console.error("Error generating translations:",e.message):console.error("An unknown error occurred:",e),process.exit(1)}})();
//# sourceMappingURL=cli.js.map
